---
title: URLSearchParams.keys()
slug: Web/API/URLSearchParams/keys
tags:
  - API
  - Method
  - Reference
  - URL API
  - URLSearchParams
---
<p>{{APIRef("URL API")}}</p>

<p>The <code><strong>keys()</strong></code> method of the {{domxref("URLSearchParams")}} interface returns an {{jsxref("Iteration_protocols",'iterator')}} allowing iteration through all keys contained in this object. The keys are {{domxref("USVString")}} objects.</p>

<div class="note">
<p><strong>Note</strong>: This method is available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">searchParams.keys();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>Returns an {{jsxref("Iteration_protocols","iterator")}}.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js;highlight:[5]">// Create a test URLSearchParams object
var searchParams = new URLSearchParams("key1=value1&amp;key2=value2");

// Display the keys
for(var key of searchParams.keys()) {
  console.log(key);
}
</pre>

<p>The result is:</p>

<pre>key1
key2</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('URL', '#interface-urlsearchparams', "keys() (see \"iterable\")")}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.URLSearchParams.keys")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("URL")}} interface.</li>
</ul>
